#ifndef EFL_GENERATED_ELM_WIDGET_ITEM_HH
#define EFL_GENERATED_ELM_WIDGET_ITEM_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_widget_item.eo.h"
}

#include "eo_base.eo.hh"
#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"
#include <eina-cxx/eina_list.hh>
#include <evas_object.eo.hh>
#include <string>

namespace elm {

struct widget_item;

}

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

namespace elm {

struct widget_item
{
   ::efl::eina::crange_list< ::evas::object > access_order_get() const;

   /// @param objs 
   ///
   void access_order_set(::efl::eina::list< ::evas::object > objs_) const;

   ::evas::object widget_get() const;

   void del() const;

#ifdef WIDGET_ITEM_PROTECTED
   void pre_notify_del() const;
#endif

   /// @param text 
   ///
   void tooltip_text_set(::efl::eina::string_view text_) const;

#ifdef WIDGET_ITEM_PROTECTED
   /// @param text 
   ///
   void tooltip_translatable_text_set(::efl::eina::string_view text_) const;
#endif

   void tooltip_unset() const;

   void cursor_unset() const;

   /// @param part 
   ///
   ::evas::object part_content_unset(::efl::eina::string_view part_) const;

#ifdef WIDGET_ITEM_PROTECTED
   void part_text_custom_update() const;
#endif

   /// @param emission 
   /// @param source 
   /// @param func 
   /// @param data 
   ///
   void signal_callback_add(::efl::eina::string_view emission_, ::efl::eina::string_view source_, Elm_Object_Item_Signal_Cb func_, void * data_) const;

   /// @param emission 
   /// @param source 
   /// @param func 
   ///
   void * signal_callback_del(::efl::eina::string_view emission_, ::efl::eina::string_view source_, Elm_Object_Item_Signal_Cb func_) const;

   /// @param emission 
   /// @param source 
   ///
   void signal_emit(::efl::eina::string_view emission_, ::efl::eina::string_view source_) const;

   /// @param txt 
   ///
   void access_info_set(::efl::eina::string_view txt_) const;

   ::evas::object access_object_get() const;

   /// @param part 
   /// @param domain 
   /// @param label 
   ///
   void domain_translatable_part_text_set(::efl::eina::string_view part_, ::efl::eina::string_view domain_, ::efl::eina::string_view label_) const;

   /// @param part 
   ///
   ::efl::eina::string_view translatable_part_text_get(::efl::eina::string_view part_) const;

#ifdef WIDGET_ITEM_PROTECTED
   void translate() const;
#endif

   /// @param part 
   /// @param domain 
   /// @param translatable 
   ///
   void domain_part_text_translatable_set(::efl::eina::string_view part_, ::efl::eina::string_view domain_, bool translatable_) const;

   ::evas::object track() const;

   void untrack() const;

   int track_get() const;

#ifdef WIDGET_ITEM_PROTECTED
   void track_cancel() const;
#endif

   /// @param del_cb 
   ///
   void del_cb_set(Evas_Smart_Cb del_cb_) const;

   /// @param func 
   /// @param data 
   /// @param del_cb 
   ///
   void tooltip_content_cb_set(Elm_Tooltip_Item_Content_Cb func_, const void * data_, Evas_Smart_Cb del_cb_) const;

   ::evas::object access_register() const;

   void access_unregister() const;

   void access_order_unset() const;

#ifdef WIDGET_ITEM_PROTECTED
   void disable() const;
#endif

#ifdef WIDGET_ITEM_PROTECTED
   bool del_pre() const;
#endif

   /// @param dir 
   ///
   ::evas::object focus_next_object_get(Elm_Focus_Direction dir_) const;

   /// @param next 
   /// @param dir 
   ///
   void focus_next_object_set(::evas::object next_, Elm_Focus_Direction dir_) const;

   /// @param dir 
   ///
   Elm_Object_Item * focus_next_item_get(Elm_Focus_Direction dir_) const;

   /// @param next_item 
   /// @param dir 
   ///
   void focus_next_item_set(Elm_Object_Item * next_item_, Elm_Focus_Direction dir_) const;

   bool tooltip_window_mode_get() const;

   bool tooltip_window_mode_set(bool disable_) const;

   ::efl::eina::string_view tooltip_style_get() const;

   void tooltip_style_set(::efl::eina::string_view style_) const;

   ::efl::eina::string_view cursor_get() const;

   void cursor_set(::efl::eina::string_view cursor_) const;

   ::efl::eina::string_view cursor_style_get() const;

   void cursor_style_set(::efl::eina::string_view style_) const;

   bool cursor_engine_only_get() const;

   void cursor_engine_only_set(bool engine_only_) const;

   ::evas::object part_content_get(::efl::eina::optional< ::efl::eina::string_view > part_) const;

   void part_content_set(::efl::eina::optional< ::efl::eina::string_view > part_, ::evas::object content_) const;

   ::efl::eina::string_view part_text_get(::efl::eina::optional< ::efl::eina::string_view > part_) const;

   void part_text_set(::efl::eina::optional< ::efl::eina::string_view > part_, ::efl::eina::string_view label_) const;

#ifdef WIDGET_ITEM_PROTECTED
   ::efl::eina::string_view part_text_custom_get(::efl::eina::string_view part_) const;
#endif

#ifdef WIDGET_ITEM_PROTECTED
   void part_text_custom_set(::efl::eina::string_view part_, ::efl::eina::string_view label_) const;
#endif

   bool focus_get() const;

   void focus_set(bool focused_) const;

   ::efl::eina::string_view style_get() const;

   void style_set(::efl::eina::string_view style_) const;

   bool disabled_get() const;

   void disabled_set(bool disable_) const;



   static Eo_Class const* _eo_class()
   {
      return(ELM_WIDGET_ITEM_CLASS);
   }

   operator ::elm::widget_item() const;
   operator ::elm::widget_item&();
   operator ::elm::widget_item const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::elm::widget_item*() const { return static_cast<::elm::widget_item*>(static_cast<D const*>(this)->p); }
      operator ::elm::widget_item const*() const { return static_cast<::elm::widget_item const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::elm::widget_item const*() const { return static_cast<::elm::widget_item const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}
/// @endcond

namespace elm {

/// @brief Class widget_item
struct widget_item
      : ::efl::eo::concrete
      , EO_CXX_INHERIT(elm_interface_atspi_accessible)
      , EO_CXX_INHERIT(elm_interface_atspi_component)
      , EO_CXX_INHERIT(eo::base)
{
   //@{
   /**
      @brief Constructs a new elm::widget_item object.

      Constructs a new elm::widget_item object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Example:
      @code
      elm::widget_item my_widget_item(efl::eo::parent = parent_object);
      @endcode

      @see widget_item(Eo* eo)
   */
   explicit widget_item(::efl::eo::parent_type _p)
      : widget_item(_ctors_call(_p))
   {}

   explicit widget_item()
      : widget_item(_ctors_call(::efl::eo::parent = nullptr))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit widget_item(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit widget_item(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   widget_item(widget_item const& other)
      : widget_item(eo_ref(other._eo_ptr()))
   {}

   ~widget_item() {}

   ::efl::eina::crange_list< ::evas::object > access_order_get() const;

   /// @param objs 
   ///
   void access_order_set(::efl::eina::list< ::evas::object > objs_) const;

   ::evas::object widget_get() const;

   void del() const;

#ifdef WIDGET_ITEM_PROTECTED
   void pre_notify_del() const;
#endif

   /// @param text 
   ///
   void tooltip_text_set(::efl::eina::string_view text_) const;

#ifdef WIDGET_ITEM_PROTECTED
   /// @param text 
   ///
   void tooltip_translatable_text_set(::efl::eina::string_view text_) const;
#endif

   void tooltip_unset() const;

   void cursor_unset() const;

   /// @param part 
   ///
   ::evas::object part_content_unset(::efl::eina::string_view part_) const;

#ifdef WIDGET_ITEM_PROTECTED
   void part_text_custom_update() const;
#endif

   /// @param emission 
   /// @param source 
   /// @param func 
   /// @param data 
   ///
   void signal_callback_add(::efl::eina::string_view emission_, ::efl::eina::string_view source_, Elm_Object_Item_Signal_Cb func_, void * data_) const;

   /// @param emission 
   /// @param source 
   /// @param func 
   ///
   void * signal_callback_del(::efl::eina::string_view emission_, ::efl::eina::string_view source_, Elm_Object_Item_Signal_Cb func_) const;

   /// @param emission 
   /// @param source 
   ///
   void signal_emit(::efl::eina::string_view emission_, ::efl::eina::string_view source_) const;

   /// @param txt 
   ///
   void access_info_set(::efl::eina::string_view txt_) const;

   ::evas::object access_object_get() const;

   /// @param part 
   /// @param domain 
   /// @param label 
   ///
   void domain_translatable_part_text_set(::efl::eina::string_view part_, ::efl::eina::string_view domain_, ::efl::eina::string_view label_) const;

   /// @param part 
   ///
   ::efl::eina::string_view translatable_part_text_get(::efl::eina::string_view part_) const;

#ifdef WIDGET_ITEM_PROTECTED
   void translate() const;
#endif

   /// @param part 
   /// @param domain 
   /// @param translatable 
   ///
   void domain_part_text_translatable_set(::efl::eina::string_view part_, ::efl::eina::string_view domain_, bool translatable_) const;

   ::evas::object track() const;

   void untrack() const;

   int track_get() const;

#ifdef WIDGET_ITEM_PROTECTED
   void track_cancel() const;
#endif

   /// @param del_cb 
   ///
   void del_cb_set(Evas_Smart_Cb del_cb_) const;

   /// @param func 
   /// @param data 
   /// @param del_cb 
   ///
   void tooltip_content_cb_set(Elm_Tooltip_Item_Content_Cb func_, const void * data_, Evas_Smart_Cb del_cb_) const;

   ::evas::object access_register() const;

   void access_unregister() const;

   void access_order_unset() const;

#ifdef WIDGET_ITEM_PROTECTED
   void disable() const;
#endif

#ifdef WIDGET_ITEM_PROTECTED
   bool del_pre() const;
#endif

   /// @param dir 
   ///
   ::evas::object focus_next_object_get(Elm_Focus_Direction dir_) const;

   /// @param next 
   /// @param dir 
   ///
   void focus_next_object_set(::evas::object next_, Elm_Focus_Direction dir_) const;

   /// @param dir 
   ///
   Elm_Object_Item * focus_next_item_get(Elm_Focus_Direction dir_) const;

   /// @param next_item 
   /// @param dir 
   ///
   void focus_next_item_set(Elm_Object_Item * next_item_, Elm_Focus_Direction dir_) const;

   bool tooltip_window_mode_get() const;

   bool tooltip_window_mode_set(bool disable_) const;

   ::efl::eina::string_view tooltip_style_get() const;

   void tooltip_style_set(::efl::eina::string_view style_) const;

   ::efl::eina::string_view cursor_get() const;

   void cursor_set(::efl::eina::string_view cursor_) const;

   ::efl::eina::string_view cursor_style_get() const;

   void cursor_style_set(::efl::eina::string_view style_) const;

   bool cursor_engine_only_get() const;

   void cursor_engine_only_set(bool engine_only_) const;

   ::evas::object part_content_get(::efl::eina::optional< ::efl::eina::string_view > part_) const;

   void part_content_set(::efl::eina::optional< ::efl::eina::string_view > part_, ::evas::object content_) const;

   ::efl::eina::string_view part_text_get(::efl::eina::optional< ::efl::eina::string_view > part_) const;

   void part_text_set(::efl::eina::optional< ::efl::eina::string_view > part_, ::efl::eina::string_view label_) const;

#ifdef WIDGET_ITEM_PROTECTED
   ::efl::eina::string_view part_text_custom_get(::efl::eina::string_view part_) const;
#endif

#ifdef WIDGET_ITEM_PROTECTED
   void part_text_custom_set(::efl::eina::string_view part_, ::efl::eina::string_view label_) const;
#endif

   bool focus_get() const;

   void focus_set(bool focused_) const;

   ::efl::eina::string_view style_get() const;

   void style_set(::efl::eina::string_view style_) const;

   bool disabled_get() const;

   void disabled_set(bool disable_) const;

   template <typename F>
   ::efl::eo::signal_connection
   callback_active_descendant_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANT_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANT_CHANGED );
   }

   template <typename T>
   void
   callback_active_descendant_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANT_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_added_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ADDED, priority_,
            &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ADDED );
   }

   template <typename T>
   void
   callback_added_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ADDED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_add_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_ADD, priority_,
            &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>,
         EO_BASE_EVENT_CALLBACK_ADD );
   }

   template <typename T>
   void
   callback_callback_add_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_ADD, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_DEL, priority_,
            &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>,
         EO_BASE_EVENT_CALLBACK_DEL );
   }

   template <typename T>
   void
   callback_callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_DEL, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_children_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED );
   }

   template <typename T>
   void
   callback_children_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_DEL, priority_,
            &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>,
         EO_BASE_EVENT_DEL );
   }

   template <typename T>
   void
   callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_DEL, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_property_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED );
   }

   template <typename T>
   void
   callback_property_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_removed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_REMOVED, priority_,
            &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_REMOVED );
   }

   template <typename T>
   void
   callback_removed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_REMOVED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_state_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED );
   }

   template <typename T>
   void
   callback_state_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_visible_data_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm::widget_item, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED );
   }

   template <typename T>
   void
   callback_visible_data_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_WIDGET_ITEM_CLASS);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::elm::widget_item::address_of<address_of>
      , ::eo_cxx::elm_interface_atspi_accessible::address_of<address_of>
      , ::eo_cxx::elm_interface_atspi_component::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::elm::widget_item* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::elm::widget_item::address_const_of<address_const_of>
      , ::eo_cxx::elm_interface_atspi_accessible::address_const_of<address_const_of>
      , ::eo_cxx::elm_interface_atspi_component::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::elm::widget_item const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ELM_WIDGET_ITEM_CLASS, _p._eo_raw);

      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::elm::widget_item) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::elm::widget_item>::value, "");

}


#include "elm_widget_item.eo.impl.hh"

#endif // EFL_GENERATED_ELM_WIDGET_ITEM_HH

